<template>
  <div :class="{ 'is-loading': isShowLoader }">
    <SectionHeading
      :task="task"
      :is-show-loader="isShowLoader"
      :header-sections="headerSections"
    />

    <SectionTab
      v-for="(group, i) in itemsGroups"
      :key="i"
      :title="group.fieldGroupTitle"
    >
      <div class="task-monitor-gutter">
        <div class="form-section-wrapper">
          <div
            v-for="(field, i) in group.fields"
            :key="i"
            class="form-section-row"
          >
            <template v-for="input in field.fieldValues">
              <ObAlert
                v-if="gelAlertType(input.data)"
                :text="getAlertText(field.fieldTitle, input)"
                :key="input.uuid"
                :hide-close-button="true"
                theme="danger"
                icon="alert"
              />

              <ObInput
                v-else
                :key="input.uuid"
                :value="input.data.value"
                :label="field.fieldTitle"
                :sub-title="input.source.type === 'participant' ? 'Введено пользователем организации' : 'Распознано'"
                :data-uuid="field.uuid"
                :icon="input.isPriority ? 'checked' : null"
                :disabled="true"
                class="form-field"
              />
            </template>

            <template v-if="links[field.uuid]">
              <p>Конфликт с данными из документов:</p>

              <div class="existing-files">
                <div
                  class="existing-file"
                  v-for="file in links[field.uuid]"
                  :key="file.uuid"
                  data-qa="download"
                  @click="downloadFile(file)"
                >
                <span class="existing-file-text">
                  {{ file.fileName }}
                </span>
                </div>
              </div>
            </template>
          </div>
        </div>
      </div>
    </SectionTab>

    <template v-if="isNewTask">
      <div class="task-monitor-gutter">
        <ObAlert
          v-for="(title, i) in fieldsTitles"
          :key="i"
          :hide-close-button="true"
          icon="alert"
          theme="warning"
          theme-icon="info"
        >
          <b>{{ title }}</b>: При сборе информации будет использован {{ title.toLowerCase() }},
          введенный вручную. В случае несогласия отмените регистрацию
        </ObAlert>
      </div>

      <div class="task-monitor-gutter task-monitor-buttons-container">
        <ObButton
          label="Подтвердить"
          class="task-monitor-buttons-container__button"
          @click="onSave"
        />

        <ObButton
          :label="getRejectTitle()"
          class="task-monitor-buttons-container__button"
          type="flat"
          :danger="true"
          @click="openRejectWarning"
        />
      </div>

      <ObModal
        ref="rejectModal"
        :title="`${getRejectTitle()}?`"
        theme="danger"
        size="medium"
      >
        <RejectWarningModal
          :is-participant="isParticipant"
          @cancel="cancelReject"
          @submit="submitReject"
        />
      </ObModal>
    </template>
  </div>
</template>

<script>
  import ObButton from 'common-components/src/obComponents/obButton'
  import ObInput from 'common-components/src/obComponents/obInput'
  import ObAlert from 'common-components/src/obComponents/obAlert'
  import ObModal from 'common-components/src/obComponents/obModal'
  import RejectWarningModal from './modal/RejectWarningModal'
  import SectionMixin from './SectionMixin'
  import api from '@/api'

  export default {
    name: 'SectionKeyFieldsConflict',
    mixins: [
      SectionMixin
    ],
    components: {
      ObButton,
      ObInput,
      ObAlert,
      ObModal,
      RejectWarningModal
    },
    data () {
      return {
        itemsGroups: [],
        taskData: {},
        links: {}
      }
    },
    watch: {
      async task () {
        this.itemsGroups = []

        if (Object.keys(this.task).length === 0) {
          return
        }

        await this.getFields()
        await this.getCardInfo()
      }
    },
    computed: {
      fieldsTitles () {
        if (!this.itemsGroups) {
          return false
        }

        // If alert must be with another title
        const replacements = {
          ['Серия и номер']: 'Номер паспорта гендиректора',
          ['Серия и номер паспорта']: 'Номер паспорта'
        }

        return this.itemsGroups.reduce((filtered, group) => {
          return filtered.concat(group.fields.map((field) => {
            return replacements[field.fieldTitle] || field.fieldTitle
          }))
        }, [])
      }
    },
    async created () {
      await this.getFields()
      await this.getCardInfo()
    },
    methods: {
      async getCardInfo () {
        this.isLoading = true

        try {
          const files = await api.taskMonitor[`get${this.currentKey}ConflictFieldsInfo`](this.task.item_uuid, {
            fieldUuids: this.itemsGroups.reduce((filtered, group) => {
              return filtered.concat(group.fields.map(field => field.uuid))
            }, [])
          })

          this.links = this.prepareLinks(files.data.domains[0].links)
        } catch (e) {
          console.error(e)

          this.$notification({
            type: 'system_notification_error',
            message: 'Ошибка загрузки данных'
          })
        }

        this.isLoading = false
      },
      async getFields () {
        this.isLoading = true

        try {
          const { data } = await api.taskMonitor[`get${this.currentKey}ConflictFields`](this.task.uuid)

          this.updateData(data.domains[0])
        } catch (e) {
          console.error(e)

          this.$notification({
            type: 'system_notification_error',
            message: 'Ошибка загрузки данных'
          })
        }

        this.isLoading = false
      },
      updateData (item) {
        this.taskData = item

        this.itemsGroups = item.groups.map(group => {
          return {
            ...group,
            _hidden: false,
            fields: group.fields.map((field) => {
              return {
                ...field,
                fieldValues: field.fieldValues.map(fieldValue => {
                  return {
                    ...fieldValue,
                    subtitle: fieldValue.source ? fieldValue.source.title : false,
                    title: fieldValue.data.value
                  }
                })
              }
            }).sort((a, b) => {
              return a.pos - b.pos
            })
          }
        }).sort((a, b) => {
          return a.fieldGroupPosition - b.fieldGroupPosition
        })
      },
      prepareLinks (links) {
        let result = {}

        this.itemsGroups.forEach((group) => {
          group.fields.forEach((field) => {
            field.fieldValues.forEach((value) => {
              const foundLinks = links.reduce((filtered, link) => {
                const found = link.docs.find(doc => doc.cardFieldValueUuid === value.uuid)

                if (found) {
                  filtered[link.uuid] ? filtered[link.uuid].push(found) : filtered[link.uuid] = [found]
                }

                return filtered
              }, {})

              Object.assign(result, foundLinks)
            })
          })
        })

        return result
      },
      async onSave () {
        this.isLoading = true

        let notificationId = new Date().getTime() + 'save'

        this.$notification({
          type: 'system_notification_in_load',
          message: 'Сохранение',
          id: notificationId
        })

        try {
          // >>> Posting task payload
          try {
            const data = {
              primaryValues: this.itemsGroups.reduce((result, group) => {
                result.push(...group.fields.reduce((fields, field) => {
                  fields.push({
                    uuid: field.fieldValues.find((item) => {
                      return item.source.type === 'participant'
                    }).uuid
                  })

                  return fields
                }, []))

                return result
              }, [])
            }

            const response = await api.taskMonitor[`post${this.currentKey}ConflictFields`](this.task.uuid, data)

            if (response && response.error) {
              throw `Ошибка при сохранении данных: ${response.error}`
            }
          } catch (e) {
            throw(e)
          }

          // >>> Archiving task
          try {
            const res = await api.taskMonitor.postConflictTaskExecuted(this.task.uuid, {
              decision: 'CONTINUE',
              worker_uuid: this.userUuid
            })

            if (res && res.error) {
              throw `Ошибка архивации задачи: ${res.error}`
            }
          } catch (e) {
            throw e
          }

          this.onTaskSuccess()
          this.onClose()

        } catch (e) {
          console.error(e)

          this.$notification({
            type: 'system_notification_error',
            message: e
          })
        }

        this.$notification({
          event: 'close',
          id: notificationId
        })

        this.isLoading = false
      },
      getRejectTitle () {
        return `Отменить регистрацию ${this.isParticipant ? 'участника' : 'ресурса'}`
      },
      openRejectWarning () {
        this.$refs.rejectModal.open()
      },
      cancelReject () {
         this.$refs.rejectModal.close()
      },
      async submitReject (payload) {
        await api.taskMonitor.postConflictTaskExecuted(this.task.uuid, {
          decision: 'REMOVE',
          worker_uuid: this.userUuid,
          ...payload
        })

        this.onClose()
      },
      async downloadFile (file) {
        const res = await api.files.getSecurityFile(file.fileUuid)

        const fileName = res.name
        const url = window.URL.createObjectURL(new Blob([res.data]))
        const link = document.createElement('a')

        link.href = url
        link.setAttribute('download', fileName)

        document.body.appendChild(link)

        link.click()

        document.body.removeChild(link)
      },
      gelAlertType (data) {
        if (data.externalServiceAnswerType === 'NO_ANSWER') {
          return 'NO_ANSWER'
        } else if (!data.value) {
          return 'NO_DATA'
        }
      },
      getAlertText (title, field) {
        let template = `<b>${title}:</b> `

        if (this.gelAlertType(field.data) === 'NO_ANSWER') {
          template += `Сервис распознавания не ответил (${field.source.title})`
        } else {
          template += 'Не распознан'
        }

        return template
      }
    }
  }
</script>

<style lang="scss" scoped>
  @import '~common-components/src/static/css/mixins';

  .task-monitor-gutter {
    padding: 0 40px;
  }

  .task-monitor-buttons-container {
    display: flex;
    align-items: center;
    margin-top: 40px;

    &__button:first-child {
      margin-right: 10px;
    }
  }

  .form-section-wrapper,
  .form-section-row:not(:last-child) {
    margin-bottom: 20px;
  }

  .form-full-block {
    width: 100%;
    margin-bottom: 20px;
  }

  .form-field {
    margin-bottom: 20px;

    &::v-deep .icon.checked {
      color: $deep-blue;
    }
  }

  .existing-files {
    display: flex;
    flex-wrap: wrap;
  }

  .existing-file {
    padding: 5px 12px;
    border-radius: 10px;
    background-color: $blue-250;
    margin: 5px 10px 0 0;
    cursor: pointer;
  }

  .existing-file-text {
    @include font-mixin(14px, 18px, 400, $shale-gray);

    text-align: center;
    position: relative;
  }
</style>
